<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f633e54d0ee56_91412322/operators/FlowchartOperator_lb5f633e54d0ee56_91412322.php';

class LinkEntitiesOperator_lb5f633e54d0ee56_91412322_op23 extends FlowchartOperator_lb5f633e54d0ee56_91412322{

    protected $objectEntity;
    protected $subjectEntity;
    protected $linkName;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($id == 'objectEntity')
                $this->objectEntity = $value;
            elseif($id == 'subjectEntity')
                $this->subjectEntity = $value;
            elseif($id=='linkName')
                $this->linkName = $value;
        }
    }

    public function setInDataPorts($params){
        parent::setInDataPorts($params);
        $this->linkName = $this->inDataPorts['linkName']['value'];
    }

    public function process($params = array()){
        if($this->checkEntity($this->objectEntity) && $this->checkEntity($this->subjectEntity) && !empty($this->linkName) ){
            $linkName = $this->linkName;
            $this->objectEntity->load_relationship($linkName);
            if(!empty($this->objectEntity->opportunities)){
                $this->objectEntity->opportunities->add($this->subjectEntity);
            }
        }else{
        }
    }

    public function getOutDataByPortId($portId){
        if($portId == 'objectEntity')
            return $this->objectEntity;
        elseif($portId == 'subjectEntity')
            return $this->subjectEntity;

        return null;
    }

    protected function checkEntity($bean){
        return !empty($bean) && $bean instanceof SugarBean && !empty($bean->id) && (empty($bean->new_with_id) || !empty($bean->pxIsSaved));
    }

}
